﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.HtmlToPdf;
using Syncfusion.WebKitHtmlConverter;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Web.Hosting;

namespace WebRoleWebkit
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    // NOTE: In order to launch WCF Test Client for testing this service, please select Service1.svc or Service1.svc.cs at the Solution Explorer and start debugging.
    public class Service1 : IService1
    {
        public MemoryStream GetData(string value)
        {
            return CreateDocument(value);
        }

        public CompositeType GetDataUsingDataContract(CompositeType composite)
        {
            if (composite == null)
            {
                throw new ArgumentNullException("composite");
            }
            if (composite.BoolValue)
            {
                composite.StringValue += "Suffix";
            }
            return composite;
        }
        public MemoryStream CreateDocument(string pathURL)
        {
            try
            {
                //Creating New Pdf Document
                PdfDocument document = new PdfDocument();

                //Setting all the margins to 0
                document.PageSettings.Margins.All = 0;

                //Adding a new Page
                PdfPage page = document.Pages.Add();

                //Unit conversion
                PdfUnitConvertor convertor = new PdfUnitConvertor();
                float width = convertor.ConvertToPixels(document.PageSettings.Width, PdfGraphicsUnit.Point);
                float height = convertor.ConvertToPixels(document.PageSettings.Height, PdfGraphicsUnit.Point);

                //Initialize WebKit rendering Engine
                WebKitHtmlConverter renderer = new WebKitHtmlConverter();
                renderer.EnableHyperlinks = true;
                renderer.EnableJavaScript = true;

                //Need to provide Qt WebKit Binaries Path
                renderer.WebKitPath = Path.Combine(HostingEnvironment.ApplicationPhysicalPath, "Assemblies");
                HtmlToPdfResult result = null;
                try
                {
                    //Conversion takes place here
                    result = renderer.Convert(pathURL, (int)width, (int)height);
                }
                catch (Exception ee)
                {
                    //If exception occurs in conversion, error will be logged in Pdf page
                    page.Graphics.DrawString(ee.ToString(), new PdfStandardFont(PdfFontFamily.Helvetica, 10), PdfBrushes.Black, new System.Drawing.PointF(100, 100));
                }

                //Setting format
                PdfMetafileLayoutFormat format = new PdfMetafileLayoutFormat();
                format.Break = PdfLayoutBreakType.FitPage;
                format.Layout = PdfLayoutType.Paginate;
                format.SplitTextLines = true;
                format.SplitImages = true;
                result.Render(page, format);

                MemoryStream ms = new MemoryStream();
                // Save and close the document.
                document.Save(ms);
                document.Close(true);
                ms.Position = 0;
                return ms;

            }
            //If exception occurs in conversion, error will be logged in Pdf page
            catch (Exception e)
            {
                PdfDocument document = new PdfDocument();
                PdfPage page = document.Pages.Add();

                page.Graphics.DrawString(e.ToString(), new PdfStandardFont(PdfFontFamily.Helvetica, 10), PdfBrushes.Black, new System.Drawing.PointF(100, 100));

                MemoryStream ms = new MemoryStream();
                // Save and close the document.
                document.Save(ms);
                ms.Position = 0;

                document.Close(true);
                return ms;
            }
        }
    }
}
